{-
The Simplest Math Problem No One Can Solve - Collatz Conjecture
https://youtu.be/094y1Z2wpJg
-}

import           Control.Monad ()
import           Debug.Trace   (trace)

main :: IO ()
main = print $ take 100 $ map f [2^1000..]

f :: Integer -> Integer
f n = s 1 n
  where
    s :: Integer -> Integer -> Integer
    s i n
      | n ==    1  = i
      | n ==    0  = i
      | n ==  (-1) = i
      | n ==  (-5) = i
      | n == (-17) = i
      | even n = s (succ i) (n `div` 2)
      | odd  n = s (succ i) (3*n + 1)

f' :: Integer -> Integer
f' n = f'' 1 n
  where
    f'' :: Integer -> Integer -> Integer
    f'' i n'
      | n' ==   1   = t' 0 + t i
      | n' ==   0   = t' 0 + t i
      | n' == (-1 ) = t' 0 + t i
      | n' == (-5 ) = t' 0 + t i
      | n' == (-17) = t' 0 + t i
      | even n' = t $ f'' (succ i) (n' `div` 2)
      | odd  n' = t $ f'' (succ i) (3*n' + 1)
      where t   = trace ("i: " ++ show i ++ ", number: " ++ show n')
            t'  = t'' $ trace ("END: " ++ show n ++ ", length: " <> show i) t''
            t'' = trace "\n#######################################################\n"

-- collatz collect
-- generate the collatz sequence and return it
cc :: Integer -> [Integer]
cc n = cc' [] n
  where
    cc' :: [Integer] -> Integer -> [Integer]
    cc' acc n
      | n ==    1  = acc <>   [1]
      | n ==    0  = acc <>   [0]
      | n ==  (-1) = acc <>  [-1]
      | n ==  (-5) = acc <>  [-5]
      | n == (-17) = acc <> [-17]
      | even n = cc' acc' (n `div` 2)
      | odd  n = cc' acc' (3*n + 1)
      where acc' = acc <> [n]
